<h1>imeji - Publish Your Scientific Multimedia Data</h1>

<h2>The imeji software</h2>
<p><b>imeji creates citable research assets by describing, enriching, sharing, exposing, linking and archiving data. </b></p>
<p><strong>The imeji software is an open-source, community driven development.</strong>
<p>The software offers a dedicated metadata management by supporting a non- restrictive metadata schema definition, as simple as liked or as complex as needed.</p>
<p>All objects within the imeji software have a unique identifier and therefore can be referenced in publications or reused in other contexts (dissemination). Large collections can be organized in different albums to focus special items of interest.</p>
<p>For a full description of the imeji software and detailled information of the functionalities please visit the <a href="http://colab.mpdl.mpg.de/mediawiki/Imeji" target="_blank" title="imeji software description">imeji software</a> page.</p>
<p>imeji is developed by the <a href="http://colab.mpdl.mpg.de/mediawiki/Imeji-Community" target="_blank" title="imeji community">imeji community</a> under the <a href="http://hub.opensolaris.org/bin/download/Main/licensing/cddllicense.txt" target="_blank">CDDL-License</a>.</p>

<h2>The imeji demo version</h2>
<p>Try the <a href="http://demo.imeji.org/" title="Go to the demo page" target="_blank">demo version</a></p>

<h2>The imeji community</h2>  
<p>The <a href="http://colab.mpdl.mpg.de/mediawiki/Imeji-Community" target="_blank" title="imeji community">imeji community</a> is an open source software developer community around the imeji software.</p>
<p>Originated in March 2012 from the <a title="MPDL" href="http://mpdl.mpg.de/" target="_blank">Max Planck Digital Library</a>, the <a title="IKB" href="http://www.kunstgeschichte.hu-berlin.de/" target="_blank">Institute of Art and Visual History</a> of the Humboldt-Universität zu Berlin and the <a title="Konrad Zuse Internet Archive" href="http://zuse.zib.de" target="_blank">Konrad Zuse Internet Archive</a> of Freie Universität Berlin, the community constantly grows.</p><p>The aim is to ensure the sustainability of the imeji software and to enable further stable software development.</p>
<p>We are open to everyone who wants to get involved and contribute to the imeji development. Please contact the <a href="mailto:imeji-community@gwdg.de" title="contact to the imeji community">community list</a> for further information.</p>

<h2>Contact &amp; Support</h2>
<p>Follow <a href="https://twitter.com/imeji_org">@imeji_org</a> on twitter</p>
<p>For general information and contact<br /> <a href="mailto:imeji-community@gwdg.de" title="contact to the imeji community">imeji-community@gwdg.de</a></p>
<p>For (not only technical) support<br /> <a href="mailto:imeji-support@gwdg.de" title="support mailinglist">imeji-support@gwdg.de</a></p>

<h2>Download</h2>
<p><a href="http://github.com/imeji-community/imeji/" target="_blank" class="gitwatch">Watch Us / Get the source code on GitHub</a></p>
<p>You can download this project in either <a href="https://github.com/imeji-community/imeji/zipball/master" target="_blank">zip</a> or <a href="https://github.com/imeji-community/imeji/tarball/master" target="_blank">tar</a> formats. <br /> You can also clone the project with <a href="http://git-scm.com" target="_blank">Git</a> by running:<pre>$ git clone https://github.com/imeji-community/imeji.git</pre></p>
